#include "QTHandler.h"

int main() {

  QTHandler* hQT = new QTHandler();

  hQT->openMovie();
  
  hQT->openQTVideoCodec();
  
  hQT->closeMovie();

  delete hQT;
  
  return EXIT_SUCCESS;
}


QTHandler::QTHandler() {
  _oMovieFilename = NULL;

  _vCodecType = kH264CodecType;

  _width = 720;
  _height = 480;
}

QTHandler::~QTHandler() {
  
  if (_oMovieFilename != NULL) {
    CFRelease(_oMovieFilename);
  }
  
}

void QTHandler::openQTVideoCodec() {

  ImageDescriptionHandle imageDesc = (ImageDescriptionHandle)NewHandle(0);
  Fixed trackWidth  = 720;
  Fixed trackHeight = 480;
  

  _err = ICMCompressionSessionOptionsCreate(NULL, &_compressSessionOpt);
  
  _err = ICMCompressionSessionCreate( NULL,
				      _width,
				      _height,
				      _vCodecType,
				      _vTimeScale,
				      _compressSessionOpt,
				      NULL,
				      &_vEncodedFrameOutputRecord,
				      &_compressSession);

  /*
  _err = ICMImageDescriptionGetProperty(imageDesc,
					kQTPropertyClass_ImageDescription, 
					kICMImageDescriptionPropertyID_ClassicTrackWidth, 
					sizeof( trackWidth ), 
					&trackWidth,
					NULL);

  _err = ICMImageDescriptionGetProperty(imageDesc, 
					kQTPropertyClass_ImageDescription, 
					kICMImageDescriptionPropertyID_ClassicTrackHeight, 
					sizeof( trackHeight ), 
					&trackHeight, 
					NULL );
  */

  _vTrack = NewMovieTrack(_movie, _width << 16, _height << 16, 0 );
  
  _vMedia = NewTrackMedia(_vTrack, VideoMediaType, 90000, 0, 0 );

  BeginMediaEdits(_vMedia);
}

void QTHandler::openMovie() {

  Handle outputMovieDataRef = NULL; 
  OSType outputMovieDataRefType = 0;

  _oMovieFilename = CFSTR("./hoge.mp4");

  _err = QTNewDataReferenceFromFullPathCFString(_oMovieFilename,
						kQTPOSIXPathStyle,
						0,
						&outputMovieDataRef,
						&outputMovieDataRefType);
  
  _err = CreateMovieStorage( outputMovieDataRef,
			     outputMovieDataRefType,
			     'TVOD',
			     0, 
			     createMovieFileDeleteCurFile,
			     &_hMovie,
			     &_movie);


  /*
  _err = QTGetDataReferenceFullPathCFString(outputMovieDataRef,
					    outputMovieDataRefType, 
					    kQTPOSIXPathStyle,
					    &outputMovieFullPathString );
  */
}


void QTHandler::closeMovie() {

  // write movie header
  AddMovieToStorage(_movie, _hMovie);

  // close movie
  CloseMovieStorage(_hMovie);
}
