/********************************************************************************
Copyright (C) Takuya.S

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
********************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "../FAACEncoder.h"
#include "FAACEncoderJNI.h"

FAACEncoder *faac;

/*
 *
 */
JNIEXPORT jboolean JNICALL Java_FAACEncoderJNI_alloc
(JNIEnv *env, jobject obj){

  faac = new FAACEncoder();

  return true;

}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_FAACEncoderJNI_delete
(JNIEnv *env, jobject obj){

  delete faac;

  return true;

}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_FAACEncoderJNI_open__
(JNIEnv *env, jobject obj) {
  
  return (faac->open());
  
}

/*
 *
 */
JNIEXPORT jboolean JNICALL Java_FAACEncoderJNI_init
(JNIEnv *env, jobject obj) {

  return (faac->init());

}

JNIEXPORT jboolean JNICALL Java_FAACEncoderJNI_init__II
(JNIEnv *env, jobject obj, jint sample, jint num) {
  return (faac->init(sample, num));
}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_FAACEncoderJNI_close
(JNIEnv *env, jobject obj) {

  return (faac->close());

}

/*
 *
 */
JNIEXPORT jbyteArray JNICALL Java_FAACEncoderJNI_getEncodedBufferRef
(JNIEnv *env, jobject obj, jbyteArray buf) {

  env->SetByteArrayRegion(buf, 0, faac->getEncodedBytes(),
			  (jbyte*)faac->getEncodedBufferRef());
  
  return buf;
}

/*
 *
 */
JNIEXPORT jint JNICALL Java_FAACEncoderJNI_getEncodedBytes
(JNIEnv *env, jobject obj) {

  return faac->getEncodedBytes();

}


/*
 *
 */
JNIEXPORT jint JNICALL Java_FAACEncoderJNI_getEncodedSamples
(JNIEnv *env, jobject obj) {
  return faac->getEncodedSamples();
}

/*
 *
 */
JNIEXPORT jint JNICALL Java_FAACEncoderJNI_getBytesWritten
(JNIEnv *env, jobject obj) {

  return faac->getBytesWritten();

}

/*
 *
 */
JNIEXPORT jboolean JNICALL Java_FAACEncoderJNI_encode__
(JNIEnv *env, jobject obj) {
  return (faac->encode());
}

/*
 *
 */
JNIEXPORT jboolean JNICALL Java_FAACEncoderJNI_encode___3BI
(JNIEnv *env, jobject obj, jbyteArray buf, jint samples) {
  jbyte raw_buf[samples * 4];

  env->GetByteArrayRegion(buf, 0, samples*4, raw_buf);

  return (faac->encode((int32_t*)raw_buf, samples));
}


/*
 *
 */
JNIEXPORT void JNICALL Java_FAACEncoderJNI_setDecoderSpecificInfo
(JNIEnv *env, jobject obj) {
  
  faac->setDecoderSpecificInfo();
  
}

/*
 *
 */
JNIEXPORT jbyteArray JNICALL Java_FAACEncoderJNI_getASC
(JNIEnv *env, jobject obj, jbyteArray buf) {

  env->SetByteArrayRegion(buf, 0, faac->getASCLength(),
			  (jbyte*)faac->getASCRef());
  
  return buf;
  
}

/*
 *
 */
JNIEXPORT jlong JNICALL Java_FAACEncoderJNI_getASCLength
(JNIEnv *evn, jobject obj) {
  return faac->getASCLength();
}

/*
 *
 */
JNIEXPORT jboolean JNICALL Java_FAACEncoderJNI_needBuffer
(JNIEnv *env, jobject obj) {
  return faac->isNeedBuffer();
}
