/********************************************************************************
Copyright (C) Takuya.S

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
********************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "../MP4Handler.h"
#include "MP4HandlerJNI.h"

MP4Handler *mp4;

/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_alloc
(JNIEnv *env, jobject obj) {

  mp4 = new MP4Handler();
  
}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_delete
(JNIEnv *env, jobject obj) {

  delete mp4;

}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_open__Ljava_lang_String_2
(JNIEnv *env, jobject obj, jstring filename) {

  return false;

}

JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_open__
(JNIEnv *env, jobject obj) {

  return (mp4->open());

}



/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_init
(JNIEnv *env, jobject obj) {
  
  return (mp4->init());

}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_close
(JNIEnv *env, jobject obj) {

  return (mp4->close());

}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_setMP4TimeScale
(JNIEnv *env, jobject obj, jint timescale) {

  return (mp4->setMP4TimeScale(timescale));
  
}


// Video

/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_addH264VideoTrack
(JNIEnv *env, jobject obj, jbyteArray buf, jint width, jint height, jint timescale) {

  jbyte native_buf[4];

  // copy srs header 1, 2, 3
  env->GetByteArrayRegion(buf, 0, 4, native_buf);

  return (mp4->addH264VideoTrack((unsigned char*)native_buf, width, height, timescale));
}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_setH264SequenceParameter
(JNIEnv *env, jobject obj, jbyteArray buf, jint length) {

  jbyte native_buf[length];

  env->GetByteArrayRegion(buf, 0, length, native_buf);

  return (mp4->setH264SequenceParameter((unsigned char *)native_buf, length));
  
}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_setH264PictureParameter
(JNIEnv *env, jobject obj, jbyteArray buf, jint length) {

  jbyte native_buf[length];

  env->GetByteArrayRegion(buf, 0, length, native_buf);

  return (mp4->setH264PictureParameter((unsigned char *)native_buf, length));

}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_writeMP4VideoSample
(JNIEnv *env, jobject obj, jbyteArray buf, jint bytes, jlong duration) {

  jbyte native_buf[bytes];

  env->GetByteArrayRegion(buf, 0, bytes, native_buf);

  return (mp4->writeMP4VideoSample((unsigned char *)native_buf, bytes, duration));  

}


// Audio

/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_addAACAudioTrack
(JNIEnv *env, jobject obj, jint timescale) {

  return (mp4->addAACAudioTrack(timescale));

}

/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_addAACAudioTrack__I_3BJ
(JNIEnv *env, jobject obj, jint timescale, jbyteArray buf, jlong len) {
  jbyte asc_buf[len];

  env->GetByteArrayRegion(buf, 0, len, asc_buf);

  return (mp4->addAACAudioTrack(timescale, (uint8_t*)asc_buf, len));
}


JNIEXPORT jbyteArray JNICALL Java_MP4HandlerJNI_getASCRef
(JNIEnv *env, jobject obj, jbyteArray buf) {

  env->GetByteArrayRegion(buf, 0, *(mp4->getASCLengthRef()), (jbyte*)*mp4->getASCRef());

  return buf;
}


JNIEXPORT jint JNICALL Java_MP4HandlerJNI_getASCLength
(JNIEnv *env, jobject ojb) {
  return (*mp4->getASCLengthRef());
}


/*
 *
 */
JNIEXPORT jboolean JNICALL Java_MP4HandlerJNI_writeMP4AudioSample
(JNIEnv *env, jobject obj, jbyteArray buf, jint bytes, jlong duration) {
  
  jbyte data[bytes];

  env->GetByteArrayRegion(buf, 0, bytes, data);

  return (mp4->writeMP4AudioSample((uint8_t *)data,
				   bytes,
				   duration));
  
}
