//// 
///  FOR JXTA EXPERIMENTATION
//
/////

import java.io.*;
import sun.misc.Signal;
import sun.misc.SignalHandler;

import java.util.*;

import net.jxta.document.*;
import net.jxta.impl.document.LiteXMLDocument;

public class EsperanceJXTA {

    private static final String DEFAULT_INPUT_FILENAME = "/Users/Pipin/Desktop/jib2.mpg";
    //private static final String DEFAULT_INPUT_FILENAME = "/Users/Pipin/Development/Visual/resources/hachi.m2p";
    private RefHandler _hMP4;
    private FFMPEGDecoderJNI _ffmpeg;
    private X264EncoderJNI   _x264;
    private FAACEncoderJNI   _faac;
    private MP4HandlerJNI    _mp4;

    private boolean _working;

    private Prototype p;


    public EsperanceJXTA() {

	//_hMP4 = new RefHandler("MP4HandlerJNI");
	
	_ffmpeg = new FFMPEGDecoderJNI();
	//_x264   = new X264EncoderJNI();
	_faac   = new FAACEncoderJNI();
	_mp4    = new MP4HandlerJNI();

	_working = true;
    }

    public void perform(Prototype p) {
	
	this.p = p;
	
	//EsperanceJXTA esp = new EsperanceJXTA();

	ESPBreaker breaker = new ESPBreaker(this);
	//Runtime.getRuntime().addShutdownHook(breaker);

	ESPSignalHandler _sig = new ESPSignalHandler(this);
	_sig.install();

	this.openCodecs();

	try {
	    breaker.start();
	} catch (Exception e) {
	    ;
	}

	this.encode();
	this.closeCodecs();

	breaker._cnt = false;

	try {
	    breaker.join();
	} catch (Exception e) {
	    ;
	}

	System.out.println("DONE DONE DONE DONE DONE");
    }
    
    protected void openCodecs() {

	StructuredTextDocument retDoc;
	Enumeration enu = null;
	TextElement ele = null;
	String name = null;
	String  val = null;
	

	byte[] sps = new byte[128];
	byte[] pps = new byte[128];
	byte[] asc = new byte[256];
	int sps_len = 0;
	int pps_len = 0;
	
	_ffmpeg.alloc();
	_ffmpeg.open(DEFAULT_INPUT_FILENAME);
	_ffmpeg.init();

	//_x264.alloc();
	//////
	StructuredTextDocument x264_alloc
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_INVOKE");
	

	x264_alloc.appendChild(x264_alloc.createElement("method", "alloc"));
	p.sendQueryOnJXTA2(x264_alloc);
	/////

	
	//_x264.open(_ffmpeg.getWidth() + 128, _ffmpeg.getHeight(), _ffmpeg.getFpsDen(), _ffmpeg.getFpsNum()); //TODO	
	/////
	StructuredTextDocument x264_open
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_INVOKE");
	
	x264_open.appendChild(x264_open.createElement("method", "open"));
	x264_open.appendChild(x264_open.createElement("arg1", Integer.toString(_ffmpeg.getWidth() + 128)));
	x264_open.appendChild(x264_open.createElement("arg2", Integer.toString(_ffmpeg.getHeight())));
	x264_open.appendChild(x264_open.createElement("arg3", Integer.toString(_ffmpeg.getFpsDen())));
	x264_open.appendChild(x264_open.createElement("arg4", Integer.toString(_ffmpeg.getFpsNum())));
	p.sendQueryOnJXTA2(x264_open);
	/////

	//_x264.init();
	/////
	StructuredTextDocument x264_init
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_INVOKE");
	
	x264_init.appendChild(x264_init.createElement("method", "init"));
	p.sendQueryOnJXTA2(x264_init);
	/////

	
	// sps_len = _x264.getSPSLen();
	/////
	StructuredTextDocument x264_getSPSLen
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_INVOKE");
	StructuredTextDocument x264_getSPSLen_Response;
	
	x264_getSPSLen.appendChild(x264_getSPSLen.createElement("method", "getSPSLen"));
	x264_getSPSLen_Response = p.sendQueryOnJXTA2(x264_getSPSLen);

	enu = x264_getSPSLen_Response.getChildren();
	ele = (TextElement)enu.nextElement();
	name = ele.getName();
	val  = ele.getTextValue();

	sps_len = Integer.parseInt(val);

	System.out.println("retval: " + Integer.parseInt(val));
	/////

	// sps = _x264.getSPSRef(sps);
	/////
	StructuredTextDocument x264_getSPSRef
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_INVOKE");
	
	x264_getSPSRef.appendChild(x264_getSPSRef.createElement("method", "getSPSRef"));
	p.sendQueryOnJXTA2Block(x264_getSPSRef);
        sps = p.getDataFromJXTA2(sps_len);
	p.doneInvocation();
	/////

	
	// pps_len = _x264.getPPSLen();
	/////
	StructuredTextDocument x264_getPPSLen
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_INVOKE");
	StructuredTextDocument x264_getPPSLen_Response;
	
	x264_getPPSLen.appendChild(x264_getPPSLen.createElement("method", "getPPSLen"));
	x264_getPPSLen_Response = p.sendQueryOnJXTA2(x264_getPPSLen);
	enu = x264_getPPSLen_Response.getChildren();
	ele = (TextElement)enu.nextElement();
	name = ele.getName();
	val  = ele.getTextValue();
	
	System.err.println("error position");
	pps_len = Integer.parseInt(val);
	System.err.println("error position");

	System.out.println("retval: " + Integer.parseInt(val));
	/////


	// pps = _x264.getPPSRef(pps);
	/////
	StructuredTextDocument x264_getPPSRef
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_INVOKE");
	
	x264_getPPSRef.appendChild(x264_getPPSRef.createElement("method", "getPPSRef"));
	p.sendQueryOnJXTA2Block(x264_getPPSRef);
	pps = p.getDataFromJXTA2(pps_len);
	p.doneInvocation();
	/////
	

	_faac.alloc();
	_faac.init(_ffmpeg.getAudioSampleRate(),
		   _ffmpeg.getAudioChannels());
	_faac.open();

	_mp4.alloc();
	_mp4.open();
	_mp4.init();

	_mp4.addH264VideoTrack(sps, _ffmpeg.getWidth(), _ffmpeg.getHeight(), 90000);
	_mp4.setH264SequenceParameter(sps, sps_len);
	_mp4.setH264PictureParameter(pps, pps_len);

	_faac.setDecoderSpecificInfo();
	_mp4.addAACAudioTrack(_ffmpeg.getAudioSampleRate(),
			      _faac.getASC(asc),
			      _faac.getASCLength());
    }

    
    protected void closeCodecs() {

	_mp4.close();
	_mp4.delete();

	_ffmpeg.close();
	_ffmpeg.delete();

	//_x264.close()
	/////
	StructuredTextDocument x264_close
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_INVOKE");
	
	x264_close.appendChild(x264_close.createElement("method", "close"));
	p.sendQueryOnJXTA2(x264_close);
	/////

	
	//_x264.delete()
	/////
	StructuredTextDocument x264_delete
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_INVOKE");
	
	x264_delete.appendChild(x264_delete.createElement("method", "delete"));
	p.sendQueryOnJXTA2(x264_delete);
	/////
	
	_faac.close();
	_faac.delete();
    }

    protected void encode() {
	int count = 0;
	int diff = 0;

	StructuredTextDocument retDoc;
	Enumeration enu = null;
	TextElement ele = null;
	String name = null;
	String  val = null;

	
	byte[] bufX264  = new byte[160000];
	byte[] bufFAAC  = new byte[18192];
	byte[] bufAudio = new byte[40000];

	if (_ffmpeg.getWidth() == 640) {
	    diff = 32;
	} else if (_ffmpeg.getWidth() == 720) {
	    diff = 48;
	}
	
	int ypixels = (_ffmpeg.getWidth() + diff) * _ffmpeg.getHeight();	
	byte[] y = new byte[ypixels];
	int ysize = 0;

	int upixels = ((_ffmpeg.getWidth() + diff) / 2) * _ffmpeg.getHeight();
	byte[] u = new byte[upixels];
	int usize = 0;
	
	int vpixels = ((_ffmpeg.getWidth() + diff) / 2) * _ffmpeg.getHeight();	
	byte[] v = new byte[vpixels];
	int vsize = 0;
	
	for (; _ffmpeg.isFinished() != true && this._working == true && count++ < 500; ) {

	    // if need more buffer for audio
	    if (_faac.needBuffer() == false) {
		
		_faac.encode();
		
		// write to mp4 file
		if (_faac.getBytesWritten() > 10) {
		    _mp4.writeMP4AudioSample(_faac.getEncodedBufferRef(bufFAAC),
					     _faac.getEncodedBytes(),
					     _faac.getEncodedSamples() / 2);
		}
	    }

	    _ffmpeg.decode();

	    if (_ffmpeg.isFinished() == true) {
		System.out.println("sys: done encoding");
		break;
	    }

	    if (_ffmpeg.doneVideo() != 0) {

		// copy frame		
		ysize = _ffmpeg.getVideoY(y);
		usize = _ffmpeg.getVideoU(u);
		vsize = _ffmpeg.getVideoV(v);

		//_x264.encode(y, u, v, ysize, usize, vsize);
		/////
		StructuredTextDocument x264_encode
		= (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
		"ESP:REMOTE_INVOKE_WITH_BYTE");
		
		x264_encode.appendChild(x264_encode.createElement("method", "encode"));
		x264_encode.appendChild(x264_encode.createElement("transfer", "3"));
		x264_encode.appendChild(x264_encode.createElement("byte1", Integer.toString(ypixels)));
		x264_encode.appendChild(x264_encode.createElement("byte2", Integer.toString(upixels)));
		x264_encode.appendChild(x264_encode.createElement("byte3", Integer.toString(vpixels)));
		x264_encode.appendChild(x264_encode.createElement("arg3", Integer.toString(ysize)));
		x264_encode.appendChild(x264_encode.createElement("arg4", Integer.toString(usize)));
		x264_encode.appendChild(x264_encode.createElement("arg5", Integer.toString(vsize)));
		p.sendQueryOnJXTA2(x264_encode);
		p.sendDataOnJXTA2(y);
		p.sendDataOnJXTA2(u);
		p.sendDataOnJXTA2(v);
		p.doneInvocation();
		
		// _x264.getBytesWritten();
		/////
		int x264_getBytesWritten_resInt = 0;
		StructuredTextDocument x264_getBytesWritten
		= (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
											  "ESP:REMOTE_INVOKE");

		StructuredTextDocument x264_getBytesWritten_Response;
		x264_getBytesWritten.appendChild(x264_getBytesWritten.createElement("method", "getBytesWritten"));
		x264_getBytesWritten_Response = p.sendQueryOnJXTA2(x264_getBytesWritten);
		System.out.println(x264_getBytesWritten_Response.toString());
		enu = x264_getBytesWritten_Response.getChildren();
		ele = (TextElement)enu.nextElement();
		name = ele.getName();
		val  = ele.getTextValue();
		
		x264_getBytesWritten_resInt = Integer.parseInt(val);
		/////


		// write to mp4 file
		if (x264_getBytesWritten_resInt > 0) {
		    System.err.println("encoded video: " +  x264_getBytesWritten_resInt);
		    byte[] nal;

		    StructuredTextDocument x264_getNalEncodedBufferRef
			= (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
												  "ESP:REMOTE_INVOKE");
		    
		    x264_getNalEncodedBufferRef.appendChild(x264_getNalEncodedBufferRef.createElement("method", "getNalEncodedBufferRef"));

		    p.sendQueryOnJXTA2Block(x264_getNalEncodedBufferRef);
		    nal = p.getDataFromJXTA2(x264_getBytesWritten_resInt);
		    p.doneInvocation();
		    
		    //_mp4.writeMP4VideoSample(_x264.getNalEncodedBufferRef(bufX264), _x264.getBytesWritten(), _ffmpeg.getVideoFrameDuration());

		    System.err.println("write to disk");
		    _mp4.writeMP4VideoSample(nal,
					     x264_getBytesWritten_resInt,
					     _ffmpeg.getVideoFrameDuration());
		    System.err.println("done disk");
		}

	    } else if (_ffmpeg.doneAudio() != 0) {
		// faac.encode
		//System.err.println("Encode Audio");
		_faac.encode(_ffmpeg.getAudioRAWRef(bufAudio),
			     _ffmpeg.getDecodedAudioSampleNum() / 2);
		
		// write to mp4 file
		if (_faac.getBytesWritten() > 10) {
		    _mp4.writeMP4AudioSample(_faac.getEncodedBufferRef(bufFAAC),
					     _faac.getEncodedBytes(),
					     _faac.getEncodedSamples() / 2);
		}

	    }
	}
    }

    public void stop() {
	System.out.println("stop");
	_working = false;
    }

    public void perform() {

    }
    
    public static void main(String[] args) {
	EsperanceJXTA esp = new EsperanceJXTA();

	ESPBreaker breaker = new ESPBreaker(esp);
	//Runtime.getRuntime().addShutdownHook(breaker);

	ESPSignalHandler _sig = new ESPSignalHandler(esp);
	_sig.install();

	esp.openCodecs();

	/*
	try {
	    breaker.start();
	} catch (Exception e) {
	    ;
	}
	*/

	esp.encode();

	esp.closeCodecs();

	/*
	breaker._cnt = false;

	try {
	    breaker.join();
	} catch (Exception e) {
	    ;
	}
	*/

	System.out.println("DONE DONE DONE DONE DONE");
    }

}

class ESPBreaker extends Thread {

    public boolean _cnt;
    EsperanceJXTA _esp;
    BufferedReader _input;

    public ESPBreaker(EsperanceJXTA esp) {
	_esp = esp;
	_cnt = true;
    }

    public void run() {

	String line = null;
	
	System.out.println("stop encoding: s");

	_input = new BufferedReader(new InputStreamReader(System.in));

	//_esp.stop();
	for (;_cnt == true;) {

	    try {
		line = _input.readLine();
	    } catch (Exception e) {
		;
	    }

	    if (line.equals("s")) {
		_esp.stop();
		break;
	    }
	}

	System.out.println("ESP Thread terminated");
	
    }
}

class ESPSignalHandler implements SignalHandler {
    private EsperanceJXTA _esp;
    private SignalHandler _hSig;

    public ESPSignalHandler(EsperanceJXTA esp) {
	_esp = esp;
    }

    public void install() {

	Signal sig = new Signal("INT");

	Signal.handle(sig, this);
    }

    public void handle(Signal sig) {
	_esp.stop();
    }
}