import net.jxta.document.*;
import net.jxta.impl.document.LiteXMLDocument;

import java.util.*;
import java.nio.*;

public class X264EncoderJNI {
    
    private Prototype parent;
    
    public void initWithParam(Prototype p) {
	this.parent = p;
	System.out.println("Class init");
    }
    
    public StructuredTextDocument invokeMethod(LiteXMLDocument doc) {

	StructuredTextDocument retDoc
	    = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType("text/xml"),
										      "ESP:REMOTE_RESPONSE");
	Enumeration enu = null;
	TextElement ele = null;
	String name = null;
	String  val = null;

	// parse to identify method name
	enu = doc.getChildren();
	ele = (TextElement)enu.nextElement();
	name = ele.getName();
	val  = ele.getTextValue();

	System.err.println("remote call: " + val);
	
	if (val.equals("alloc")) {
	    
	    this.alloc();

	    retDoc.appendChild(retDoc.createElement("open", "null"));
	    
	} else if (val.equals("delete")) {
	    
	    this.delete();

	    retDoc.appendChild(retDoc.createElement("delete", "null"));
	    
	} else if (val.equals("open")) {
	    int arg1;
	    int arg2;
	    int arg3;
	    int arg4;

	    ele = (TextElement)enu.nextElement();
	    val  = ele.getTextValue();
	    arg1 = Integer.parseInt(val);

	    ele = (TextElement)enu.nextElement();
	    val  = ele.getTextValue();
	    arg2 = Integer.parseInt(val);

	    ele = (TextElement)enu.nextElement();
	    val  = ele.getTextValue();
	    arg3 = Integer.parseInt(val);

	    ele = (TextElement)enu.nextElement();
	    val  = ele.getTextValue();
	    arg4 = Integer.parseInt(val);

	    this.open(arg1, arg2, arg3, arg4);

	    retDoc.appendChild(retDoc.createElement("open", "null"));

	} else if (val.equals("init")) {

	    this.init();

	    retDoc.appendChild(retDoc.createElement("init", "null"));

	} else if (val.equals("close")) {

	    this.close();

	    retDoc.appendChild(retDoc.createElement("close", "null"));

	} else if (val.equals("getSPSLen")) {

	    retDoc.appendChild(retDoc.createElement("getSPSLen", Integer.toString(this.getSPSLen())));

	} else if (val.equals("getSPSRef")) {

	    byte[] b = new byte[this.getSPSLen()];

	    this.getSPSRef(b);

	    retDoc.appendChild(retDoc.createElement("getSPSRef", "null"));

	    parent.sendDataOnJXTA2(b);

	} else if (val.equals("getPPSLen")) {

	    retDoc.appendChild(retDoc.createElement("getPPSLen", Integer.toString(this.getPPSLen())));

	} else if (val.equals("getPPSRef")) {

	    byte[] b = new byte[this.getPPSLen()];

	    this.getPPSRef(b);

	    retDoc.appendChild(retDoc.createElement("getPPSRef", "null"));

	    parent.sendDataOnJXTA2(b);

	} else if (val.equals("getBytesWritten")) {

	    retDoc.appendChild(retDoc.createElement("getBytesWritten", Integer.toString(this.getBytesWritten())));

	} else if (val.equals("encode")) {
	    Enumeration en;
	    ByteBuffer bbff;
	    
	    byte[] y;
	    byte[] u;
	    byte[] v;

	    int ys, us, vs;

	    en = parent.getMethodArgs();
	
	    bbff = (ByteBuffer)en.nextElement();
	    y = bbff.array();

	    bbff = (ByteBuffer)en.nextElement();
	    u = bbff.array();

	    bbff = (ByteBuffer)en.nextElement();
	    v = bbff.array();

	    enu.nextElement(); // transfer
	    enu.nextElement(); // arg1
	    enu.nextElement(); // arg2
	    enu.nextElement(); // arg3
	    
	    ele = (TextElement)enu.nextElement();
	    val  = ele.getTextValue();
	    ys = Integer.parseInt(val);

	    ele = (TextElement)enu.nextElement();
	    val  = ele.getTextValue();
	    us = Integer.parseInt(val);

	    ele = (TextElement)enu.nextElement();
	    val  = ele.getTextValue();
	    vs = Integer.parseInt(val);
	    
	    this.encode(y, u, v, ys, us, vs);

	    retDoc.appendChild(retDoc.createElement("encode", "hidoine"));
	    
	} else if (val.equals("getNalEncodedBufferRef")) {

	    byte[] b = new byte[this.getBytesWritten()];

	    this.getNalEncodedBufferRef(b);

	    retDoc.appendChild(retDoc.createElement("getNalEncodedBufferRef", ""));

	    parent.sendDataOnJXTA2(b);
	}
	
	System.err.println("return remote invocation");

	return retDoc;
    }
    
    public X264EncoderJNI() {

    }

    static {
	System.loadLibrary("X264EncoderJNI");
    }

    public native void alloc();

    public native void delete();

    public native boolean open(int width,
			       int height,
			       int fps_den,
			       int fps_num);

    public native boolean init();

    public native boolean close();

    public native boolean encode();

    public native boolean encode(byte[] y, byte[] u, byte[] v,
				 int ys, int bs, int vs);

    // Get
    public native int getWidth();

    public native int getHeight();

    //public native int getSPSRef(byte[] srs);

    public native byte[] getSPSRef(byte[] srs);

    //public native int getPPSRef(byte[] pps);

    public native byte[] getPPSRef(byte[] pps);

    public native int getSPSLen();

    public native int getPPSLen();

    public native byte[] getNalEncodedBufferRef(byte[] buf);

    public native int  getBytesWritten();

    // Set
    public native void setWidth(int width);

    public native void setHeight(int height);

    public native void setFraneRateFactor(int num, int den);

    public native void setX264Picture(byte[] input_yuv);

    public static void main(String[] args) {
	X264EncoderJNI x264 = new X264EncoderJNI();
	x264.open(720, 480, 30000, 1001);
	x264.init();
	x264.close();
    }
}
    